<?php
/**
 * @package n3t Seznam Captcha
 * @author Pavel Poles - n3t.cz
 * @copyright (C) 2012-2017 - Pavel Poles - n3t.cz
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
**/

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );
jimport( 'fof.utils.ip.ip' );

class plgCaptchaN3tSeznamCaptcha extends JPlugin
{

	public function __construct($subject, $config)
	{
		parent::__construct($subject, $config);
		$this->loadLanguage();
	}
  
	public function onInit($id)
	{
    if (!$this->params->def('enable_captcha', 1)) return;

		$doc = JFactory::getDocument();
    if ($this->params->def('theme', 'dark-icons'))
      JHtml::stylesheet('plg_n3tseznamcaptcha/'.$this->params->def('theme', 'dark-icons').'.css', false, true);
   
    JHtml::_('jquery.framework');
    JHtml::_('jquery.ui');
    JHtml::script('plg_n3tseznamcaptcha/jquery.captcha.min.js', true, true);
		$doc->addScriptDeclaration("
      jQuery(function(){
        jQuery('.seznam-captcha').n3tSeznamCaptcha({
          'url': '".addslashes(JURI::root())."'          
        });
      });"
		);

    if( !ini_get('allow_url_fopen') && (!extension_loaded('curl') || !function_exists('curl_exec') ) ) {
      throw new Exception(JText::_('PLG_CAPTCHA_N3TSEZNAMCAPTCHA_NO_DOWNLOAD_SUPPORT'));
    }
  }

	public function onDisplay($name, $id, $class)
	{
    if (!$this->params->def('enable_captcha', 1)) return;

    return '<div class="seznam-captcha loading"></div>';
	}

	public function onCheckAnswer($code)
	{
    $input = JFactory::getApplication()->input;
    
    if ($this->params->def('enable_captcha', 1))
    {            
      $hash = $input->get('n3t_seznam_captcha_hash', '', 'cmd');       
      $answer = $input->get('n3t_seznam_captcha', '', 'cmd');

  		if ($hash == null || strlen($hash) == 0 || $answer == null || strlen($answer) == 0)
  		{
  			$this->_subject->setError(JText::_('PLG_CAPTCHA_N3TSEZNAMCAPTCHA_EMPTY_ANSWER'));
  			return false;
  		}
      if (!$this->_checkAnswer($hash, $answer)) {
  		  $this->_subject->setError(JText::_('PLG_CAPTCHA_N3TSEZNAMCAPTCHA_WRONG_ANSWER'));
  		  return false;
      }
    }

    $check = array();
    $check['ip'] = FOFUtilsIp::getIp();
    $check['ipv6'] = FOFUtilsIp::isIPv6($check['ip']);
    if ($check['ipv6'])
      $check['reverseip'] = implode(':',array_reverse(explode(':',$check['ip'])));    
    else
      $check['reverseip'] = implode('.',array_reverse(explode('.',$check['ip'])));

    $ip_whitelist = preg_split('/\s*\n\s*/', $this->params->def('ip_whitelist', ''));
    if (FOFUtilsIp::IPinList($check['ip'], $ip_whitelist)) {
      return true;
    }

    $ip_blacklist = preg_split('/\s*\n\s*/', $this->params->def('ip_blacklist', ''));
    if (FOFUtilsIp::IPinList($check['ip'], $ip_blacklist)) {
		  $this->_subject->setError(JText::sprintf('PLG_CAPTCHA_N3TSEZNAMCAPTCHA_BLACKLIST',$check['ip']));
		  return false;
    }

    if ($this->params->def('check_stopforumspam', '0') && !$this->_checkStopForumSpam($check)) {
		  $this->_subject->setError(JText::sprintf('PLG_CAPTCHA_N3TSEZNAMCAPTCHA_BLACKLIST',$check['ip']));
		  return false;
    }

    if ($this->params->def('check_botscout', '0') && !$this->_checkBotScout($check)) {
		  $this->_subject->setError(JText::sprintf('PLG_CAPTCHA_N3TSEZNAMCAPTCHA_BLACKLIST',$check['ip']));
		  return false;
    }

    if ($this->params->def('check_spamhaus', '0') && !$this->_checkSpamHaus($check)) {
		  $this->_subject->setError(JText::sprintf('PLG_CAPTCHA_N3TSEZNAMCAPTCHA_BLACKLIST',$check['ip']));
		  return false;
    }

    if ($this->params->def('check_sorbs', '0') && !$this->_checkSorbs($check)) {
		  $this->_subject->setError(JText::sprintf('PLG_CAPTCHA_N3TSEZNAMCAPTCHA_BLACKLIST',$check['ip']));
		  return false;
    }

    if ($this->params->def('check_spamcop', '0') && !$this->_checkSpamCop($check)) {
		  $this->_subject->setError(JText::sprintf('PLG_CAPTCHA_N3TSEZNAMCAPTCHA_BLACKLIST',$check['ip']));
		  return false;
    }

    if ($this->params->def('check_honeypot', '0') && !$this->_checkHoneyPot($check)) {
		  $this->_subject->setError(JText::sprintf('PLG_CAPTCHA_N3TSEZNAMCAPTCHA_BLACKLIST',$check['ip']));
		  return false;
    }

    return true;
  }

  function onAjaxN3tSeznamCaptcha() { 
    $app = JFactory::getApplication(); 
    $input = JFactory::getApplication()->input;
    switch($input->get('task','','cmd')) {
      case 'layout':
      default:
        $path = JPluginHelper::getLayoutPath($this->_type, $this->_name, $this->params->def('theme', 'dark-icons'));        
        ob_start();        
				include $path;
				return ob_get_clean();
        break;
        
      case 'create':
        $app->setHeader('Cache-Control', 'max-age=0,no-cache,no-store,post-check=0,pre-check=0,must-revalidate', true);
        $app->setHeader('Expires', 'Sat, 26 Jul 1997 05:00:00 GMT', true);
    
        return $this->_getUrl('http://captcha.seznam.cz/captcha.create');
        break;        

      case 'audio':
        $audio = $this->_getUrl('http://captcha.seznam.cz/captcha.getAudio?hash='.$input->get('hash'));

        $app->setHeader('Cache-Control', 'max-age=0,no-cache,no-store,post-check=0,pre-check=0,must-revalidate', true);
        $app->setHeader('Expires', 'Sat, 26 Jul 1997 05:00:00 GMT', true);
        $app->setHeader('Content-Type', 'audio/x-wav', true);
        $app->setHeader('Content-Disposition', 'attachment; filename=captcha.wav', true);        
        $app->setHeader('Content-Length', strlen($audio), true);
        
        return $audio;
        break;        
    }
  }
  
  private function _checkAnswer($hash, $answer)
  {
    $url = 'http://captcha.seznam.cz/captcha.check?hash='.$hash.'&code='.$answer;
    if (extension_loaded('curl') && function_exists('curl_exec')) {
      $c = curl_init();
      curl_setopt($c, CURLOPT_RETURNTRANSFER, 1);
      curl_setopt($c, CURLOPT_URL, $url);
      curl_exec($c);
      $info = curl_getinfo($c);
      curl_close($c);
      return $info['http_code'] == 200;
    } else if (ini_get('allow_url_fopen')) {
      $headers = get_headers($url);
      if (is_array($headers)
      && isset($headers[0])
      && strpos($headers[0],'200'))
        return true;
    }
    return false;
  }

  private function _getUrl($url)
  {
    $response = '';
    if (extension_loaded('curl') && function_exists('curl_exec')) {
      $c = curl_init();
			curl_setopt($c, CURLOPT_URL, $url);
			curl_setopt($c, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($c, CURLOPT_HEADER, 0);
			$response = @curl_exec($c);
			curl_close($c);
    } else if (function_exists('file_get_contents') && ini_get('allow_url_fopen')) {
      $response = @file_get_contents($url);
    }
    return $response;
  }

  private function _checkStopForumSpam($data)
  {
    if ($data['ip'] && !$data['ipv6']) {
      $address = 'http://api.stopforumspam.org/api?f=serial&ip='.$data['ip'];
      $response = $this->_getUrl($address);
      if ($response) {
        $response = unserialize($response);
        if ($response['success'] && $response['ip']['appears']) return false;
      }
    }
    return true;
  }

  private function _checkSorbs($data)
  {
    if ($data['reverseip']) {
      $address = $data['reverseip'].'.l2.spews.dnsbl.sorbs.net.';
      $response = @gethostbyname($address);
      if ($response != $address) return false;

      $address = $data['reverseip'].'.problems.dnsbl.sorbs.net.';
      $response = @gethostbyname($address);
      if ($response != $address) return false;
    }
    return true;
  }

  private function _checkBotScout($data)
  {
    if ($data['ip']) {
      $address = 'http://botscout.com/test/?ip='.$data['ip'];
      if ($this->params->def('botscout_api_key', ''))
        $address .= '&key='.$this->params->get('botscout_api_key');
      $response = $this->_getUrl($address);
      if ($response) {
        $response = explode('|',$response);
        if ($response[0] == 'Y') return false;
      }
    }
    return true;
  }

  private function _checkSpamHaus($data)
  {
    if ($data['reverseip']) {
      $address = $data['reverseip'].'.zen.spamhaus.org.';
      $response = @gethostbyname($address);
      if ($response != $address) return false;
    }
    return true;
  }

  private function _checkSpamCop($data)
  {
    if ($data['reverseip']) {
      $address = $data['reverseip'].'.bl.spamcop.net.';
      $response = @gethostbyname($address);
      if ($response == '127.0.0.2') return false;
    }
    return true;
  }

  private function _checkHoneyPot($data)
  {
    if (!$data['ipv6'] && $data['reverseip'] && $this->params->def('honeypot_api_key', '')) {
      $address = $this->params->get('honeypot_api_key').'.'.$data['reverseip'].'.dnsbl.httpbl.org.';
      $response = @gethostbyname($address);
      if ($response != $address) {
        $response = explode('.',$response);
        if ($response[2] > 0 && $response[3] > 1) return false;
      }
    }
    return true;
  }
}